
<!DOCTYPE html>
<html class="client-nojs" lang="en" dir="ltr">
<head>
<meta charset="UTF-8"/>
<title>Serverless computing - Wikipedia</title>
<script>document.documentElement.className="client-js";RLCONF={"wgBreakFrames":!1,"wgSeparatorTransformTable":["",""],"wgDigitTransformTable":["",""],"wgDefaultDateFormat":"dmy","wgMonthNames":["","January","February","March","April","May","June","July","August","September","October","November","December"],"wgRequestId":"XojQ2QpAICMAAHWxJUkAAABT","wgCSPNonce":!1,"wgCanonicalNamespace":"","wgCanonicalSpecialPageName":!1,"wgNamespaceNumber":0,"wgPageName":"Serverless_computing","wgTitle":"Serverless computing","wgCurRevisionId":944226992,"wgRevisionId":944226992,"wgArticleId":51040757,"wgIsArticle":!0,"wgIsRedirect":!1,"wgAction":"view","wgUserName":null,"wgUserGroups":["*"],"wgCategories":["Serverless computing","Cloud computing"],"wgPageContentLanguage":"en","wgPageContentModel":"wikitext","wgRelevantPageName":"Serverless_computing","wgRelevantArticleId":51040757,"wgIsProbablyEditable":!0,"wgRelevantPageIsProbablyEditable":!0,"wgRestrictionEdit":[],"wgRestrictionMove":[],
"wgMediaViewerOnClick":!0,"wgMediaViewerEnabledByDefault":!0,"wgPopupsReferencePreviews":!1,"wgPopupsConflictsWithNavPopupGadget":!1,"wgVisualEditor":{"pageLanguageCode":"en","pageLanguageDir":"ltr","pageVariantFallbacks":"en"},"wgMFDisplayWikibaseDescriptions":{"search":!0,"nearby":!0,"watchlist":!0,"tagline":!1},"wgWMESchemaEditAttemptStepOversample":!1,"wgULSCurrentAutonym":"English","wgNoticeProject":"wikipedia","wgWikibaseItemId":"Q3958022","wgCentralAuthMobileDomain":!1,"wgEditSubmitButtonLabelPublish":!0};RLSTATE={"ext.globalCssJs.user.styles":"ready","site.styles":"ready","noscript":"ready","user.styles":"ready","ext.globalCssJs.user":"ready","user":"ready","user.options":"loading","ext.cite.styles":"ready","mediawiki.toc.styles":"ready","skins.vector.styles.legacy":"ready","wikibase.client.init":"ready","ext.visualEditor.desktopArticleTarget.noscript":"ready","ext.uls.interlanguage":"ready","ext.wikimediaBadges":"ready"};RLPAGEMODULES=[
"ext.cite.ux-enhancements","site","mediawiki.page.startup","skins.vector.js","mediawiki.page.ready","mediawiki.toc","ext.gadget.ReferenceTooltips","ext.gadget.charinsert","ext.gadget.refToolbar","ext.gadget.extra-toolbar-buttons","ext.gadget.switcher","ext.centralauth.centralautologin","ext.popups","ext.visualEditor.desktopArticleTarget.init","ext.visualEditor.targetLoader","ext.eventLogging","ext.wikimediaEvents","ext.navigationTiming","ext.uls.compactlinks","ext.uls.interface","ext.cx.eventlogging.campaigns","ext.quicksurveys.init","ext.centralNotice.geoIP","ext.centralNotice.startUp"];</script>
<script>(RLQ=window.RLQ||[]).push(function(){mw.loader.implement("user.options@1hzgi",function($,jQuery,require,module){/*@nomin*/mw.user.tokens.set({"patrolToken":"+\\","watchToken":"+\\","csrfToken":"+\\"});
});});</script>
<link rel="stylesheet" href="/w/load.php?lang=en&amp;modules=ext.cite.styles%7Cext.uls.interlanguage%7Cext.visualEditor.desktopArticleTarget.noscript%7Cext.wikimediaBadges%7Cmediawiki.toc.styles%7Cskins.vector.styles.legacy%7Cwikibase.client.init&amp;only=styles&amp;skin=vector"/>
<script async="" src="/w/load.php?lang=en&amp;modules=startup&amp;only=scripts&amp;raw=1&amp;skin=vector"></script>
<meta name="ResourceLoaderDynamicStyles" content=""/>
<link rel="stylesheet" href="/w/load.php?lang=en&amp;modules=site.styles&amp;only=styles&amp;skin=vector"/>
<meta name="generator" content="MediaWiki 1.35.0-wmf.26"/>
<meta name="referrer" content="origin"/>
<meta name="referrer" content="origin-when-crossorigin"/>
<meta name="referrer" content="origin-when-cross-origin"/>
<link rel="alternate" type="application/x-wiki" title="Edit this page" href="/w/index.php?title=Serverless_computing&amp;action=edit"/>
<link rel="edit" title="Edit this page" href="/w/index.php?title=Serverless_computing&amp;action=edit"/>
<link rel="apple-touch-icon" href="/static/apple-touch/wikipedia.png"/>
<link rel="shortcut icon" href="/static/favicon/wikipedia.ico"/>
<link rel="search" type="application/opensearchdescription+xml" href="/w/opensearch_desc.php" title="Wikipedia (en)"/>
<link rel="EditURI" type="application/rsd+xml" href="//en.wikipedia.org/w/api.php?action=rsd"/>
<link rel="license" href="//creativecommons.org/licenses/by-sa/3.0/"/>
<link rel="alternate" type="application/atom+xml" title="Wikipedia Atom feed" href="/w/index.php?title=Special:RecentChanges&amp;feed=atom"/>
<link rel="canonical" href="https://en.wikipedia.org/wiki/Serverless_computing"/>
<link rel="dns-prefetch" href="//login.wikimedia.org"/>
<link rel="dns-prefetch" href="//meta.wikimedia.org" />
<!--[if lt IE 9]><script src="/w/resources/lib/html5shiv/html5shiv.js"></script><![endif]-->
</head>
<body class="mediawiki ltr sitedir-ltr mw-hide-empty-elt ns-0 ns-subject mw-editable page-Serverless_computing rootpage-Serverless_computing skin-vector action-view">
<div id="mw-page-base" class="noprint"></div>
<div id="mw-head-base" class="noprint"></div>
<div id="content" class="mw-body" role="main">
	<a id="top"></a>
	<div id="siteNotice" class="mw-body-content"><!-- CentralNotice --></div>
	<div class="mw-indicators mw-body-content">
</div>

	<h1 id="firstHeading" class="firstHeading" lang="en">Serverless computing</h1>
	
	<div id="bodyContent" class="mw-body-content">
		<div id="siteSub" class="noprint">From Wikipedia, the free encyclopedia</div>
		<div id="contentSub"></div>
		
		
		<div id="jump-to-nav"></div>
		<a class="mw-jump-link" href="#mw-head">Jump to navigation</a>
		<a class="mw-jump-link" href="#p-search">Jump to search</a>
		<div id="mw-content-text" lang="en" dir="ltr" class="mw-content-ltr"><div class="mw-parser-output"><p><b>Serverless computing</b> is a <a href="/wiki/Cloud_computing" title="Cloud computing">cloud computing</a> <a href="/wiki/Execution_model" title="Execution model">execution model</a> in which the cloud provider runs the <a href="/wiki/Server_(computing)" title="Server (computing)">server</a>, and dynamically manages the allocation of machine resources. Pricing is based on the actual amount of resources consumed by an application, rather than on pre-purchased units of capacity.<sup id="cite_ref-techcrunch-lambda_1-0" class="reference"><a href="#cite_note-techcrunch-lambda-1">&#91;1&#93;</a></sup> It can be a form of <a href="/wiki/Utility_computing" title="Utility computing">utility computing</a>.
</p><p>Serverless computing can simplify the process of <a href="/wiki/Software_deployment" title="Software deployment">deploying code</a> into production. Scaling, capacity planning and maintenance operations may be hidden from the developer or operator. Serverless code can be used in conjunction with code deployed in traditional styles, such as <a href="/wiki/Microservices" title="Microservices">microservices</a>. Alternatively, applications can be written to be purely serverless and use no provisioned servers at all.<sup id="cite_ref-lambda-api-gateway_2-0" class="reference"><a href="#cite_note-lambda-api-gateway-2">&#91;2&#93;</a></sup>
</p><p>This should not be confused with computing or networking models that do not require an actual server to function, such as <a href="/wiki/Peer-to-peer" title="Peer-to-peer">peer-to-peer</a> (P2P).
</p>
<div id="toc" class="toc" role="navigation" aria-labelledby="mw-toc-heading"><input type="checkbox" role="button" id="toctogglecheckbox" class="toctogglecheckbox" style="display:none" /><div class="toctitle" lang="en" dir="ltr"><h2 id="mw-toc-heading">Contents</h2><span class="toctogglespan"><label class="toctogglelabel" for="toctogglecheckbox"></label></span></div>
<ul>
<li class="toclevel-1 tocsection-1"><a href="#Serverless_runtimes"><span class="tocnumber">1</span> <span class="toctext">Serverless runtimes</span></a></li>
<li class="toclevel-1 tocsection-2"><a href="#Serverless_databases"><span class="tocnumber">2</span> <span class="toctext">Serverless databases</span></a></li>
<li class="toclevel-1 tocsection-3"><a href="#Advantages"><span class="tocnumber">3</span> <span class="toctext">Advantages</span></a>
<ul>
<li class="toclevel-2 tocsection-4"><a href="#Cost"><span class="tocnumber">3.1</span> <span class="toctext">Cost</span></a></li>
<li class="toclevel-2 tocsection-5"><a href="#Elasticity_versus_scalability"><span class="tocnumber">3.2</span> <span class="toctext">Elasticity versus scalability</span></a></li>
<li class="toclevel-2 tocsection-6"><a href="#Productivity"><span class="tocnumber">3.3</span> <span class="toctext">Productivity</span></a></li>
</ul>
</li>
<li class="toclevel-1 tocsection-7"><a href="#Disadvantages"><span class="tocnumber">4</span> <span class="toctext">Disadvantages</span></a>
<ul>
<li class="toclevel-2 tocsection-8"><a href="#Performance"><span class="tocnumber">4.1</span> <span class="toctext">Performance</span></a></li>
<li class="toclevel-2 tocsection-9"><a href="#Resource_limits"><span class="tocnumber">4.2</span> <span class="toctext">Resource limits</span></a></li>
<li class="toclevel-2 tocsection-10"><a href="#Monitoring_and_debugging"><span class="tocnumber">4.3</span> <span class="toctext">Monitoring and debugging</span></a></li>
<li class="toclevel-2 tocsection-11"><a href="#Security"><span class="tocnumber">4.4</span> <span class="toctext">Security</span></a></li>
<li class="toclevel-2 tocsection-12"><a href="#Privacy"><span class="tocnumber">4.5</span> <span class="toctext">Privacy</span></a></li>
<li class="toclevel-2 tocsection-13"><a href="#Standards"><span class="tocnumber">4.6</span> <span class="toctext">Standards</span></a></li>
<li class="toclevel-2 tocsection-14"><a href="#Vendor_lock-in"><span class="tocnumber">4.7</span> <span class="toctext">Vendor lock-in</span></a></li>
</ul>
</li>
<li class="toclevel-1 tocsection-15"><a href="#See_also"><span class="tocnumber">5</span> <span class="toctext">See also</span></a></li>
<li class="toclevel-1 tocsection-16"><a href="#References"><span class="tocnumber">6</span> <span class="toctext">References</span></a></li>
<li class="toclevel-1 tocsection-17"><a href="#Further_reading"><span class="tocnumber">7</span> <span class="toctext">Further reading</span></a></li>
</ul>
</div>

<h2><span class="mw-headline" id="Serverless_runtimes">Serverless runtimes</span><span class="mw-editsection"><span class="mw-editsection-bracket">[</span><a href="/w/index.php?title=Serverless_computing&amp;action=edit&amp;section=1" title="Edit section: Serverless runtimes">edit</a><span class="mw-editsection-bracket">]</span></span></h2>
<p>Most, but not all, serverless vendors offer compute runtimes, also known as <a href="/wiki/Function_as_a_service" title="Function as a service">function as a service (FaaS)</a> platforms, which execute application logic but do not store data. The first "pay as you go" code execution platform was Zimki, released in 2006, but it was not commercially successful.<sup id="cite_ref-3" class="reference"><a href="#cite_note-3">&#91;3&#93;</a></sup> In 2008, Google released <a href="/wiki/Google_App_Engine" title="Google App Engine">Google App Engine</a>, which featured metered billing for applications that used a custom Python framework, but could not execute arbitrary code.<sup id="cite_ref-4" class="reference"><a href="#cite_note-4">&#91;4&#93;</a></sup>  PiCloud, released in 2010, offered FaaS support for Python.<sup id="cite_ref-5" class="reference"><a href="#cite_note-5">&#91;5&#93;</a></sup>
</p><p><a href="/wiki/Amazon_Lambda" class="mw-redirect" title="Amazon Lambda">AWS Lambda</a>, introduced by Amazon in 2014,<sup id="cite_ref-techcrunch-lambda-launch_6-0" class="reference"><a href="#cite_note-techcrunch-lambda-launch-6">&#91;6&#93;</a></sup> was the first public cloud infrastructure vendor with an abstract serverless computing offering. It is supported by a number of additional AWS serverless tools such as AWS Serverless Application Model (AWS SAM) <a href="/wiki/Amazon_CloudWatch" class="mw-redirect" title="Amazon CloudWatch">Amazon CloudWatch</a>, and others. 
</p><p>Google Cloud Platform offers <a href="/wiki/Google_Cloud_Functions" class="mw-redirect" title="Google Cloud Functions">Google Cloud Functions</a> since 2016.<sup id="cite_ref-vb-gcf_7-0" class="reference"><a href="#cite_note-vb-gcf-7">&#91;7&#93;</a></sup>
</p><p>IBM offers IBM Cloud Functions in the public IBM Cloud since 2016.<sup id="cite_ref-wsk-pressrelease_8-0" class="reference"><a href="#cite_note-wsk-pressrelease-8">&#91;8&#93;</a></sup>
</p><p><a href="/wiki/Microsoft_Azure" title="Microsoft Azure">Microsoft Azure</a> offers Azure Functions, offered both in the Azure public cloud or on-premises via Azure Stack.<sup id="cite_ref-techcrunch-azure_9-0" class="reference"><a href="#cite_note-techcrunch-azure-9">&#91;9&#93;</a></sup>
</p>
<h2><span class="mw-headline" id="Serverless_databases">Serverless databases</span><span class="mw-editsection"><span class="mw-editsection-bracket">[</span><a href="/w/index.php?title=Serverless_computing&amp;action=edit&amp;section=2" title="Edit section: Serverless databases">edit</a><span class="mw-editsection-bracket">]</span></span></h2>
<p>Several serverless <a href="/wiki/Distributed_data_store" title="Distributed data store">databases</a> have emerged in the last few years. These systems extend the serverless execution model to the <a href="/wiki/Relational_database_management_system" class="mw-redirect" title="Relational database management system">RDBMS</a>, eliminating the need to provision or scale <a href="/wiki/Hardware_virtualization" title="Hardware virtualization">virtualized</a> or physical database hardware.
</p><p><a href="/wiki/Amazon_Aurora" title="Amazon Aurora">Amazon Aurora</a> offers a serverless version of its databases, based on <a href="/wiki/MySQL" title="MySQL">MySQL</a> and <a href="/wiki/PostgreSQL" title="PostgreSQL">PostgreSQL</a>, providing on-demand, auto-scaling configurations. <sup id="cite_ref-10" class="reference"><a href="#cite_note-10">&#91;10&#93;</a></sup>
</p><p><a href="/wiki/Azure_Data_Lake" title="Azure Data Lake">Azure Data Lake</a> is a highly scalable data storage and analytics service. The service is hosted in <a href="/wiki/Microsoft_Azure" title="Microsoft Azure">Azure</a>, Microsoft's public cloud. <a href="/wiki/Azure_Data_Lake" title="Azure Data Lake">Azure Data Lake Analytics</a> provides a distributed infrastructure that can dynamically allocate or de-allocate resources so customers pay for only the services they use.
</p><p><a href="/wiki/Google_Cloud_Datastore" title="Google Cloud Datastore">Google Cloud Datastore</a> is an <a href="/wiki/Eventual_consistency" title="Eventual consistency">eventually-consistent</a> document store. It offers the database component of Google App Engine as a standalone service. <a href="/wiki/Firebase" title="Firebase">Firebase</a>, also owned by Google,<sup id="cite_ref-11" class="reference"><a href="#cite_note-11">&#91;11&#93;</a></sup> includes a <a href="/wiki/Hierarchical_database_model" title="Hierarchical database model">hierarchical database</a> and is available via fixed and pay-as-you-go plans.<sup id="cite_ref-12" class="reference"><a href="#cite_note-12">&#91;12&#93;</a></sup>
</p>
<h2><span class="mw-headline" id="Advantages">Advantages</span><span class="mw-editsection"><span class="mw-editsection-bracket">[</span><a href="/w/index.php?title=Serverless_computing&amp;action=edit&amp;section=3" title="Edit section: Advantages">edit</a><span class="mw-editsection-bracket">]</span></span></h2>
<h3><span class="mw-headline" id="Cost">Cost</span><span class="mw-editsection"><span class="mw-editsection-bracket">[</span><a href="/w/index.php?title=Serverless_computing&amp;action=edit&amp;section=4" title="Edit section: Cost">edit</a><span class="mw-editsection-bracket">]</span></span></h3>
<p>Serverless can be more cost-effective than renting or purchasing a fixed quantity of servers,<sup id="cite_ref-Everybody_is_talking_about_serverless_architecture_13-0" class="reference"><a href="#cite_note-Everybody_is_talking_about_serverless_architecture-13">&#91;13&#93;</a></sup> which generally involves significant periods of underutilization or idle time.<sup id="cite_ref-techcrunch-lambda_1-1" class="reference"><a href="#cite_note-techcrunch-lambda-1">&#91;1&#93;</a></sup> It can even be more cost-efficient than provisioning an <a href="/wiki/Autoscaling" title="Autoscaling">autoscaling group</a>, due to more efficient <a href="/wiki/Bin_packing_problem" title="Bin packing problem">bin-packing</a> of the underlying machine resources.
</p><p>This can be described as pay-as-you-go computing<sup id="cite_ref-Everybody_is_talking_about_serverless_architecture_13-1" class="reference"><a href="#cite_note-Everybody_is_talking_about_serverless_architecture-13">&#91;13&#93;</a></sup> or bare-code<sup id="cite_ref-Everybody_is_talking_about_serverless_architecture_13-2" class="reference"><a href="#cite_note-Everybody_is_talking_about_serverless_architecture-13">&#91;13&#93;</a></sup> as you are charged based solely upon the time and memory allocated to run your code; without associated fees for idle time.<sup id="cite_ref-Everybody_is_talking_about_serverless_architecture_13-3" class="reference"><a href="#cite_note-Everybody_is_talking_about_serverless_architecture-13">&#91;13&#93;</a></sup>
</p><p>Immediate cost benefits are related to the lack of operating systems costs, including: licences, installation, dependencies, maintenance, support, and patching.<sup id="cite_ref-Everybody_is_talking_about_serverless_architecture_13-4" class="reference"><a href="#cite_note-Everybody_is_talking_about_serverless_architecture-13">&#91;13&#93;</a></sup>
</p>
<h3><span class="mw-headline" id="Elasticity_versus_scalability">Elasticity versus scalability</span><span class="mw-editsection"><span class="mw-editsection-bracket">[</span><a href="/w/index.php?title=Serverless_computing&amp;action=edit&amp;section=5" title="Edit section: Elasticity versus scalability">edit</a><span class="mw-editsection-bracket">]</span></span></h3>
<div role="note" class="hatnote navigation-not-searchable">See also: <a href="/wiki/Scalability" title="Scalability">scalability</a> and <a href="/wiki/Elasticity_(cloud_computing)" title="Elasticity (cloud computing)">Elasticity (cloud computing)</a></div>
<p>In addition, a serverless architecture means that developers and operators do not need to spend time setting up and tuning autoscaling policies or systems; the cloud provider is responsible for scaling the capacity to the demand.<sup id="cite_ref-techcrunch-lambda_1-2" class="reference"><a href="#cite_note-techcrunch-lambda-1">&#91;1&#93;</a></sup><sup id="cite_ref-techcrunch-azure_9-1" class="reference"><a href="#cite_note-techcrunch-azure-9">&#91;9&#93;</a></sup><sup id="cite_ref-Everybody_is_talking_about_serverless_architecture_13-5" class="reference"><a href="#cite_note-Everybody_is_talking_about_serverless_architecture-13">&#91;13&#93;</a></sup>. As Google puts it: ‘from prototype to production to planet-scale.’<sup id="cite_ref-Everybody_is_talking_about_serverless_architecture_13-6" class="reference"><a href="#cite_note-Everybody_is_talking_about_serverless_architecture-13">&#91;13&#93;</a></sup>
</p><p>As cloud native systems inherently scale down as well as up, these systems are known as elastic rather than scalable.
</p><p>Small teams of developers are able to run code themselves without the dependence upon teams of infrastructure and support engineers; more developers are becoming <a href="/wiki/DevOps" title="DevOps">DevOps</a> skilled and distinctions between being a software developer or hardware engineer are blurring.<sup id="cite_ref-Everybody_is_talking_about_serverless_architecture_13-7" class="reference"><a href="#cite_note-Everybody_is_talking_about_serverless_architecture-13">&#91;13&#93;</a></sup>
</p>
<h3><span class="mw-headline" id="Productivity">Productivity</span><span class="mw-editsection"><span class="mw-editsection-bracket">[</span><a href="/w/index.php?title=Serverless_computing&amp;action=edit&amp;section=6" title="Edit section: Productivity">edit</a><span class="mw-editsection-bracket">]</span></span></h3>
<p>With <a href="/wiki/Function_as_a_service" title="Function as a service">function as a service</a>, the units of code exposed to the outside world are simple event driven <a href="/wiki/Subroutine" title="Subroutine">functions</a>. This means that typically, the programmer does not have to worry about <a href="/wiki/Multithreading_(software)" class="mw-redirect" title="Multithreading (software)">multithreading</a> or directly handling <a href="/wiki/HTTP" class="mw-redirect" title="HTTP">HTTP</a> requests in their code, simplifying the task of back-end software development.
</p>
<h2><span class="mw-headline" id="Disadvantages">Disadvantages</span><span class="mw-editsection"><span class="mw-editsection-bracket">[</span><a href="/w/index.php?title=Serverless_computing&amp;action=edit&amp;section=7" title="Edit section: Disadvantages">edit</a><span class="mw-editsection-bracket">]</span></span></h2>
<h3><span class="mw-headline" id="Performance">Performance</span><span class="mw-editsection"><span class="mw-editsection-bracket">[</span><a href="/w/index.php?title=Serverless_computing&amp;action=edit&amp;section=8" title="Edit section: Performance">edit</a><span class="mw-editsection-bracket">]</span></span></h3>
<p>Infrequently-used serverless code may suffer from greater response <a href="/wiki/Latency_(engineering)" title="Latency (engineering)">latency</a> than code that is continuously running on a dedicated server, virtual machine, or container. This is because, unlike with autoscaling, the cloud provider typically "spins down" the serverless code completely when not in use. This means that if the runtime (for example, the <a href="/wiki/Java_(programming_language)" title="Java (programming language)">Java</a> runtime) requires a significant amount of time to start up, it will create additional latency. 
</p>
<h3><span class="mw-headline" id="Resource_limits">Resource limits</span><span class="mw-editsection"><span class="mw-editsection-bracket">[</span><a href="/w/index.php?title=Serverless_computing&amp;action=edit&amp;section=9" title="Edit section: Resource limits">edit</a><span class="mw-editsection-bracket">]</span></span></h3>
<p>Serverless computing is not suited to some computing workloads, such as <a href="/wiki/High-performance_computing" class="mw-redirect" title="High-performance computing">high-performance computing</a>, because of the resource limits imposed by cloud providers, and also because it would likely be cheaper to bulk-provision the number of servers believed to be required at any given point in time. 
</p>
<h3><span class="mw-headline" id="Monitoring_and_debugging">Monitoring and debugging</span><span class="mw-editsection"><span class="mw-editsection-bracket">[</span><a href="/w/index.php?title=Serverless_computing&amp;action=edit&amp;section=10" title="Edit section: Monitoring and debugging">edit</a><span class="mw-editsection-bracket">]</span></span></h3>
<p>Diagnosing performance or excessive resource usage problems with serverless code may be more difficult than with traditional server code, because although entire functions can be timed,<sup id="cite_ref-lambda-api-gateway_2-1" class="reference"><a href="#cite_note-lambda-api-gateway-2">&#91;2&#93;</a></sup> there is typically no ability to dig into more detail by attaching <a href="/wiki/Profiling_(computer_programming)" title="Profiling (computer programming)">profilers</a>, <a href="/wiki/Debugger" title="Debugger">debuggers</a> or <a href="/wiki/Application_Performance_Management" class="mw-redirect" title="Application Performance Management">APM</a> tools. Furthermore, the environment in which the code runs is typically not <a href="/wiki/Open-source_software" title="Open-source software">open source</a>, so its performance characteristics cannot be precisely replicated in a <a href="/wiki/Deployment_environment#Development" title="Deployment environment">local environment</a>.
</p>
<h3><span class="mw-headline" id="Security">Security</span><span class="mw-editsection"><span class="mw-editsection-bracket">[</span><a href="/w/index.php?title=Serverless_computing&amp;action=edit&amp;section=11" title="Edit section: Security">edit</a><span class="mw-editsection-bracket">]</span></span></h3>
<p>Serverless is sometimes mistakenly considered as more secure than traditional architectures. While this is true to some extent because OS vulnerabilities are taken care of by the cloud provider, the total attack surface is significantly larger as there are many more components to the application compared to traditional architectures and each component is an entry point to the serverless application. Moreover, the security solutions customers used to have to protect their cloud workloads become irrelevant as customers cannot control and install anything on the <a href="/wiki/Endpoint_security" title="Endpoint security">endpoint</a> and <a href="/wiki/Network_security" title="Network security">network</a> level such as an <a href="/wiki/Intrusion_detection_system" title="Intrusion detection system">intrusion detection/prevention system</a> (IDS/IPS). <sup id="cite_ref-14" class="reference"><a href="#cite_note-14">&#91;14&#93;</a></sup>
</p><p>This is intensified by the mono-culture properties of the entire server network. (A single flaw can be applied globally.) According to protego, the "solution to secure serverless apps is close partnership between developers, DevOps, and AppSec, also known as DevSecOps. Find the balance where developers don’t own security, but they aren’t absolved from responsibility either. Take steps to make it everyone’s problem. Create cross-functional teams and work towards tight integration between security specialists and development teams. Collaborate so your organization can resolve security risks at the speed of serverless."<sup id="cite_ref-15" class="reference"><a href="#cite_note-15">&#91;15&#93;</a></sup>
</p>
<h3><span class="mw-headline" id="Privacy">Privacy</span><span class="mw-editsection"><span class="mw-editsection-bracket">[</span><a href="/w/index.php?title=Serverless_computing&amp;action=edit&amp;section=12" title="Edit section: Privacy">edit</a><span class="mw-editsection-bracket">]</span></span></h3>
<p>Many serverless function environments are based on <a href="/wiki/Proprietary_software" title="Proprietary software">proprietary</a> public cloud environments. Here, some <a href="/wiki/Privacy" title="Privacy">privacy</a> implications have to be considered, such as shared resources and access by external employees. However, serverless computing can also be done on private cloud environment or even on-premises, using for example the <a href="/wiki/Kubernetes" title="Kubernetes">Kubernetes</a> platform. This gives companies full control over privacy mechanisms, just as with hosting in traditional server setups.
</p>
<h3><span class="mw-headline" id="Standards">Standards</span><span class="mw-editsection"><span class="mw-editsection-bracket">[</span><a href="/w/index.php?title=Serverless_computing&amp;action=edit&amp;section=13" title="Edit section: Standards">edit</a><span class="mw-editsection-bracket">]</span></span></h3>
<p>Serverless computing is covered by International Data Center Authority (IDCA) in their Framework AE360. However, the part related to portability can be an issue when moving business logic from one public cloud to another for which the <a href="/wiki/Docker_(software)" title="Docker (software)">Docker</a> solution was created. Cloud Native Computing Foundation (CNCF) is also working on developing a specification with Oracle.<sup id="cite_ref-16" class="reference"><a href="#cite_note-16">&#91;16&#93;</a></sup>
</p>
<h3><span class="mw-headline" id="Vendor_lock-in">Vendor lock-in</span><span class="mw-editsection"><span class="mw-editsection-bracket">[</span><a href="/w/index.php?title=Serverless_computing&amp;action=edit&amp;section=14" title="Edit section: Vendor lock-in">edit</a><span class="mw-editsection-bracket">]</span></span></h3>
<p>Serverless computing is provided as a third-party service. Applications and software that run in the serverless environment are by default locked to a specific cloud vendor.<sup id="cite_ref-17" class="reference"><a href="#cite_note-17">&#91;17&#93;</a></sup> Therefore, serverless can cause multiple issues during migration.<sup id="cite_ref-18" class="reference"><a href="#cite_note-18">&#91;18&#93;</a></sup> 
</p>
<h2><span class="mw-headline" id="See_also">See also</span><span class="mw-editsection"><span class="mw-editsection-bracket">[</span><a href="/w/index.php?title=Serverless_computing&amp;action=edit&amp;section=15" title="Edit section: See also">edit</a><span class="mw-editsection-bracket">]</span></span></h2>
<ul><li><a href="/wiki/AWS_Lambda" title="AWS Lambda">AWS Lambda</a></li>
<li><a href="/wiki/Cloud_Computing" class="mw-redirect" title="Cloud Computing">Cloud Computing</a></li>
<li><a href="/wiki/Function_as_a_service" title="Function as a service">Function as a service</a></li></ul>
<h2><span class="mw-headline" id="References">References</span><span class="mw-editsection"><span class="mw-editsection-bracket">[</span><a href="/w/index.php?title=Serverless_computing&amp;action=edit&amp;section=16" title="Edit section: References">edit</a><span class="mw-editsection-bracket">]</span></span></h2>
<div class="reflist" style="list-style-type: decimal;">
<div class="mw-references-wrap mw-references-columns"><ol class="references">
<li id="cite_note-techcrunch-lambda-1"><span class="mw-cite-backlink">^ <a href="#cite_ref-techcrunch-lambda_1-0"><sup><i><b>a</b></i></sup></a> <a href="#cite_ref-techcrunch-lambda_1-1"><sup><i><b>b</b></i></sup></a> <a href="#cite_ref-techcrunch-lambda_1-2"><sup><i><b>c</b></i></sup></a></span> <span class="reference-text"><cite class="citation web">Miller, Ron (24 Nov 2015). <a rel="nofollow" class="external text" href="https://techcrunch.com/2015/11/24/aws-lamda-makes-serverless-applications-a-reality/">"AWS Lambda Makes Serverless Applications A Reality"</a>. <i><a href="/wiki/TechCrunch" title="TechCrunch">TechCrunch</a></i><span class="reference-accessdate">. Retrieved <span class="nowrap">10 July</span> 2016</span>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Ajournal&amp;rft.genre=unknown&amp;rft.jtitle=TechCrunch&amp;rft.atitle=AWS+Lambda+Makes+Serverless+Applications+A+Reality&amp;rft.date=2015-11-24&amp;rft.aulast=Miller&amp;rft.aufirst=Ron&amp;rft_id=https%3A%2F%2Ftechcrunch.com%2F2015%2F11%2F24%2Faws-lamda-makes-serverless-applications-a-reality%2F&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><style data-mw-deduplicate="TemplateStyles:r935243608">.mw-parser-output cite.citation{font-style:inherit}.mw-parser-output .citation q{quotes:"\"""\"""'""'"}.mw-parser-output .id-lock-free a,.mw-parser-output .citation .cs1-lock-free a{background:url("//upload.wikimedia.org/wikipedia/commons/thumb/6/65/Lock-green.svg/9px-Lock-green.svg.png")no-repeat;background-position:right .1em center}.mw-parser-output .id-lock-limited a,.mw-parser-output .id-lock-registration a,.mw-parser-output .citation .cs1-lock-limited a,.mw-parser-output .citation .cs1-lock-registration a{background:url("//upload.wikimedia.org/wikipedia/commons/thumb/d/d6/Lock-gray-alt-2.svg/9px-Lock-gray-alt-2.svg.png")no-repeat;background-position:right .1em center}.mw-parser-output .id-lock-subscription a,.mw-parser-output .citation .cs1-lock-subscription a{background:url("//upload.wikimedia.org/wikipedia/commons/thumb/a/aa/Lock-red-alt-2.svg/9px-Lock-red-alt-2.svg.png")no-repeat;background-position:right .1em center}.mw-parser-output .cs1-subscription,.mw-parser-output .cs1-registration{color:#555}.mw-parser-output .cs1-subscription span,.mw-parser-output .cs1-registration span{border-bottom:1px dotted;cursor:help}.mw-parser-output .cs1-ws-icon a{background:url("//upload.wikimedia.org/wikipedia/commons/thumb/4/4c/Wikisource-logo.svg/12px-Wikisource-logo.svg.png")no-repeat;background-position:right .1em center}.mw-parser-output code.cs1-code{color:inherit;background:inherit;border:inherit;padding:inherit}.mw-parser-output .cs1-hidden-error{display:none;font-size:100%}.mw-parser-output .cs1-visible-error{font-size:100%}.mw-parser-output .cs1-maint{display:none;color:#33aa33;margin-left:0.3em}.mw-parser-output .cs1-subscription,.mw-parser-output .cs1-registration,.mw-parser-output .cs1-format{font-size:95%}.mw-parser-output .cs1-kern-left,.mw-parser-output .cs1-kern-wl-left{padding-left:0.2em}.mw-parser-output .cs1-kern-right,.mw-parser-output .cs1-kern-wl-right{padding-right:0.2em}</style></span>
</li>
<li id="cite_note-lambda-api-gateway-2"><span class="mw-cite-backlink">^ <a href="#cite_ref-lambda-api-gateway_2-0"><sup><i><b>a</b></i></sup></a> <a href="#cite_ref-lambda-api-gateway_2-1"><sup><i><b>b</b></i></sup></a></span> <span class="reference-text"><cite class="citation web">MSV, Janakiram (16 July 2015). <a rel="nofollow" class="external text" href="https://www.forbes.com/sites/janakirammsv/2015/07/16/paas-vendors-watch-out-amazon-is-all-set-to-disrupt-the-market/">"PaaS Vendors, Watch Out! Amazon Is All Set To Disrupt the Market"</a><span class="reference-accessdate">. Retrieved <span class="nowrap">10 July</span> 2016</span>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Abook&amp;rft.genre=unknown&amp;rft.btitle=PaaS+Vendors%2C+Watch+Out%21+Amazon+Is+All+Set+To+Disrupt+the+Market&amp;rft.date=2015-07-16&amp;rft.aulast=MSV&amp;rft.aufirst=Janakiram&amp;rft_id=https%3A%2F%2Fwww.forbes.com%2Fsites%2Fjanakirammsv%2F2015%2F07%2F16%2Fpaas-vendors-watch-out-amazon-is-all-set-to-disrupt-the-market%2F&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></span>
</li>
<li id="cite_note-3"><span class="mw-cite-backlink"><b><a href="#cite_ref-3">^</a></b></span> <span class="reference-text"><cite class="citation web">Williams, Christopher. <a rel="nofollow" class="external text" href="https://www.theregister.co.uk/2007/09/25/zimki_fotango_shut/">"Fotango to smother Zimki on Christmas Eve"</a><span class="reference-accessdate">. Retrieved <span class="nowrap">2017-06-11</span></span>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Abook&amp;rft.genre=unknown&amp;rft.btitle=Fotango+to+smother+Zimki+on+Christmas+Eve&amp;rft.aulast=Williams&amp;rft.aufirst=Christopher&amp;rft_id=https%3A%2F%2Fwww.theregister.co.uk%2F2007%2F09%2F25%2Fzimki_fotango_shut%2F&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></span>
</li>
<li id="cite_note-4"><span class="mw-cite-backlink"><b><a href="#cite_ref-4">^</a></b></span> <span class="reference-text"><cite class="citation web"><a rel="nofollow" class="external text" href="https://code.google.com/appengine/docs/python/runtime.html">"Python Runtime Environment | App Engine standard environment for Python | Google Cloud Platform"</a>. <i>Google Cloud Platform</i><span class="reference-accessdate">. Retrieved <span class="nowrap">2017-06-11</span></span>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Ajournal&amp;rft.genre=unknown&amp;rft.jtitle=Google+Cloud+Platform&amp;rft.atitle=Python+Runtime+Environment+%7C+App+Engine+standard+environment+for+Python+%7C+Google+Cloud+Platform&amp;rft_id=https%3A%2F%2Fcode.google.com%2Fappengine%2Fdocs%2Fpython%2Fruntime.html&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></span>
</li>
<li id="cite_note-5"><span class="mw-cite-backlink"><b><a href="#cite_ref-5">^</a></b></span> <span class="reference-text"><cite class="citation web"><a rel="nofollow" class="external text" href="https://techcrunch.com/2010/07/19/picloud-launches-serverless-computing-platform-to-the-public/">"PiCloud Launches Serverless Computing Platform To The Public"</a>. <i>TechCrunch</i><span class="reference-accessdate">. Retrieved <span class="nowrap">2018-12-17</span></span>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Ajournal&amp;rft.genre=unknown&amp;rft.jtitle=TechCrunch&amp;rft.atitle=PiCloud+Launches+Serverless+Computing+Platform+To+The+Public&amp;rft_id=https%3A%2F%2Ftechcrunch.com%2F2010%2F07%2F19%2Fpicloud-launches-serverless-computing-platform-to-the-public%2F&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></span>
</li>
<li id="cite_note-techcrunch-lambda-launch-6"><span class="mw-cite-backlink"><b><a href="#cite_ref-techcrunch-lambda-launch_6-0">^</a></b></span> <span class="reference-text"><cite class="citation web">Miller, Ron (13 Nov 2014). <a rel="nofollow" class="external text" href="https://techcrunch.com/2014/11/13/amazon-launches-lambda-an-event-driven-compute-service/">"Amazon Launches Lambda, An Event-Driven Compute Service"</a>. <i><a href="/wiki/TechCrunch" title="TechCrunch">TechCrunch</a></i><span class="reference-accessdate">. Retrieved <span class="nowrap">10 July</span> 2016</span>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Ajournal&amp;rft.genre=unknown&amp;rft.jtitle=TechCrunch&amp;rft.atitle=Amazon+Launches+Lambda%2C+An+Event-Driven+Compute+Service&amp;rft.date=2014-11-13&amp;rft.aulast=Miller&amp;rft.aufirst=Ron&amp;rft_id=https%3A%2F%2Ftechcrunch.com%2F2014%2F11%2F13%2Famazon-launches-lambda-an-event-driven-compute-service%2F&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></span>
</li>
<li id="cite_note-vb-gcf-7"><span class="mw-cite-backlink"><b><a href="#cite_ref-vb-gcf_7-0">^</a></b></span> <span class="reference-text"><cite class="citation web">Novet, Jordan (9 February 2016). <a rel="nofollow" class="external text" href="https://venturebeat.com/2016/02/09/google-has-quietly-launched-its-answer-to-aws-lambda/">"Google has quietly launched its answer to AWS Lambda"</a>. <i><a href="/wiki/VentureBeat" title="VentureBeat">VentureBeat</a></i><span class="reference-accessdate">. Retrieved <span class="nowrap">10 July</span> 2016</span>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Ajournal&amp;rft.genre=unknown&amp;rft.jtitle=VentureBeat&amp;rft.atitle=Google+has+quietly+launched+its+answer+to+AWS+Lambda&amp;rft.date=2016-02-09&amp;rft.aulast=Novet&amp;rft.aufirst=Jordan&amp;rft_id=https%3A%2F%2Fventurebeat.com%2F2016%2F02%2F09%2Fgoogle-has-quietly-launched-its-answer-to-aws-lambda%2F&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></span>
</li>
<li id="cite_note-wsk-pressrelease-8"><span class="mw-cite-backlink"><b><a href="#cite_ref-wsk-pressrelease_8-0">^</a></b></span> <span class="reference-text"><cite class="citation web">Zimmerman, Mike (23 February 2016). <a rel="nofollow" class="external text" href="http://www-03.ibm.com/press/us/en/pressrelease/49158.wss">"IBM Unveils Fast, Open Alternative to Event-Driven Programming"</a>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Abook&amp;rft.genre=unknown&amp;rft.btitle=IBM+Unveils+Fast%2C+Open+Alternative+to+Event-Driven+Programming&amp;rft.date=2016-02-23&amp;rft.aulast=Zimmerman&amp;rft.aufirst=Mike&amp;rft_id=http%3A%2F%2Fwww-03.ibm.com%2Fpress%2Fus%2Fen%2Fpressrelease%2F49158.wss&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></span>
</li>
<li id="cite_note-techcrunch-azure-9"><span class="mw-cite-backlink">^ <a href="#cite_ref-techcrunch-azure_9-0"><sup><i><b>a</b></i></sup></a> <a href="#cite_ref-techcrunch-azure_9-1"><sup><i><b>b</b></i></sup></a></span> <span class="reference-text"><cite class="citation web">Miller, Ron (31 March 2016). <a rel="nofollow" class="external text" href="https://techcrunch.com/2016/03/31/microsoft-answers-aws-lambdas-event-triggered-serverless-apps-with-azure-functions/">"Microsoft answers AWS Lambda's event-triggered serverless apps with Azure Functions"</a>. <i><a href="/wiki/TechCrunch" title="TechCrunch">TechCrunch</a></i><span class="reference-accessdate">. Retrieved <span class="nowrap">10 July</span> 2016</span>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Ajournal&amp;rft.genre=unknown&amp;rft.jtitle=TechCrunch&amp;rft.atitle=Microsoft+answers+AWS+Lambda%27s+event-triggered+serverless+apps+with+Azure+Functions&amp;rft.date=2016-03-31&amp;rft.aulast=Miller&amp;rft.aufirst=Ron&amp;rft_id=https%3A%2F%2Ftechcrunch.com%2F2016%2F03%2F31%2Fmicrosoft-answers-aws-lambdas-event-triggered-serverless-apps-with-azure-functions%2F&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></span>
</li>
<li id="cite_note-10"><span class="mw-cite-backlink"><b><a href="#cite_ref-10">^</a></b></span> <span class="reference-text"><cite class="citation web"><a rel="nofollow" class="external text" href="https://aws.amazon.com/rds/aurora/serverless/">"Amazon Aurora Serverless - On-demand, Auto-scaling Relational Database - AWS"</a>. <i>Amazon Web Services, Inc</i><span class="reference-accessdate">. Retrieved <span class="nowrap">2019-08-08</span></span>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Ajournal&amp;rft.genre=unknown&amp;rft.jtitle=Amazon+Web+Services%2C+Inc.&amp;rft.atitle=Amazon+Aurora+Serverless+-+On-demand%2C+Auto-scaling+Relational+Database+-+AWS&amp;rft_id=https%3A%2F%2Faws.amazon.com%2Frds%2Faurora%2Fserverless%2F&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></span>
</li>
<li id="cite_note-11"><span class="mw-cite-backlink"><b><a href="#cite_ref-11">^</a></b></span> <span class="reference-text"><cite class="citation web">Lardinois, Frederic. <a rel="nofollow" class="external text" href="https://techcrunch.com/2014/10/21/google-acquires-firebase-to-help-developers-build-better-realtime-apps/">"Google Acquires Firebase To Help Developers Build Better Real-Time Apps | TechCrunch"</a><span class="reference-accessdate">. Retrieved <span class="nowrap">2017-06-11</span></span>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Abook&amp;rft.genre=unknown&amp;rft.btitle=Google+Acquires+Firebase+To+Help+Developers+Build+Better+Real-Time+Apps+%7C+TechCrunch&amp;rft.aulast=Lardinois&amp;rft.aufirst=Frederic&amp;rft_id=https%3A%2F%2Ftechcrunch.com%2F2014%2F10%2F21%2Fgoogle-acquires-firebase-to-help-developers-build-better-realtime-apps%2F&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></span>
</li>
<li id="cite_note-12"><span class="mw-cite-backlink"><b><a href="#cite_ref-12">^</a></b></span> <span class="reference-text"><cite class="citation web">Darrow, Barb (2013-06-20). <a rel="nofollow" class="external text" href="https://gigaom.com/2013/06/20/firebase-gets-5-6m-to-launch-its-paid-product-and-fire-up-its-base/">"Firebase gets $5.6M to launch its paid product and fire up its base"</a>. <i>gigaom.com</i><span class="reference-accessdate">. Retrieved <span class="nowrap">2017-06-11</span></span>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Ajournal&amp;rft.genre=unknown&amp;rft.jtitle=gigaom.com&amp;rft.atitle=Firebase+gets+%245.6M+to+launch+its+paid+product+and+fire+up+its+base&amp;rft.date=2013-06-20&amp;rft.aulast=Darrow&amp;rft.aufirst=Barb&amp;rft_id=https%3A%2F%2Fgigaom.com%2F2013%2F06%2F20%2Ffirebase-gets-5-6m-to-launch-its-paid-product-and-fire-up-its-base%2F&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></span>
</li>
<li id="cite_note-Everybody_is_talking_about_serverless_architecture-13"><span class="mw-cite-backlink">^ <a href="#cite_ref-Everybody_is_talking_about_serverless_architecture_13-0"><sup><i><b>a</b></i></sup></a> <a href="#cite_ref-Everybody_is_talking_about_serverless_architecture_13-1"><sup><i><b>b</b></i></sup></a> <a href="#cite_ref-Everybody_is_talking_about_serverless_architecture_13-2"><sup><i><b>c</b></i></sup></a> <a href="#cite_ref-Everybody_is_talking_about_serverless_architecture_13-3"><sup><i><b>d</b></i></sup></a> <a href="#cite_ref-Everybody_is_talking_about_serverless_architecture_13-4"><sup><i><b>e</b></i></sup></a> <a href="#cite_ref-Everybody_is_talking_about_serverless_architecture_13-5"><sup><i><b>f</b></i></sup></a> <a href="#cite_ref-Everybody_is_talking_about_serverless_architecture_13-6"><sup><i><b>g</b></i></sup></a> <a href="#cite_ref-Everybody_is_talking_about_serverless_architecture_13-7"><sup><i><b>h</b></i></sup></a></span> <span class="reference-text"><cite class="citation web">Jamieson, Frazer (4 September 2017). <a rel="nofollow" class="external text" href="http://www.bcs.org/content/conWebDoc/58491">"Losing the server? Everybody is talking about serverless architecture"</a>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Abook&amp;rft.genre=unknown&amp;rft.btitle=Losing+the+server%3F+Everybody+is+talking+about+serverless+architecture&amp;rft.date=2017-09-04&amp;rft.aulast=Jamieson&amp;rft.aufirst=Frazer&amp;rft_id=http%3A%2F%2Fwww.bcs.org%2Fcontent%2FconWebDoc%2F58491&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></span>
</li>
<li id="cite_note-14"><span class="mw-cite-backlink"><b><a href="#cite_ref-14">^</a></b></span> <span class="reference-text"><a rel="nofollow" class="external free" href="https://www.puresec.io/serverless-security-top-12-csa-puresec">https://www.puresec.io/serverless-security-top-12-csa-puresec</a></span>
</li>
<li id="cite_note-15"><span class="mw-cite-backlink"><b><a href="#cite_ref-15">^</a></b></span> <span class="reference-text"><cite class="citation web">Solow, Hillel (2019-02-05). <a rel="nofollow" class="external text" href="https://www.protego.io/serverless-computing-security-risks-challenges/">"Serverless Computing Security Risks &amp; Challenges"</a>. <i>protego.io</i><span class="reference-accessdate">. Retrieved <span class="nowrap">2019-03-20</span></span>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Ajournal&amp;rft.genre=unknown&amp;rft.jtitle=protego.io&amp;rft.atitle=Serverless+Computing+Security+Risks+%26+Challenges&amp;rft.date=2019-02-05&amp;rft.aulast=Solow&amp;rft.aufirst=Hillel&amp;rft_id=https%3A%2F%2Fwww.protego.io%2Fserverless-computing-security-risks-challenges%2F&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></span>
</li>
<li id="cite_note-16"><span class="mw-cite-backlink"><b><a href="#cite_ref-16">^</a></b></span> <span class="reference-text"><cite class="citation news"><a rel="nofollow" class="external text" href="https://www.sdxcentral.com/articles/news/cncf-oracle-boost-serverless-standardization-efforts/2018/05/">"CNCF, Oracle Boost Serverless Standardization Efforts"</a>. <i>SDxCentral</i><span class="reference-accessdate">. Retrieved <span class="nowrap">2018-11-24</span></span>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Ajournal&amp;rft.genre=article&amp;rft.jtitle=SDxCentral&amp;rft.atitle=CNCF%2C+Oracle+Boost+Serverless+Standardization+Efforts&amp;rft_id=https%3A%2F%2Fwww.sdxcentral.com%2Farticles%2Fnews%2Fcncf-oracle-boost-serverless-standardization-efforts%2F2018%2F05%2F&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></span>
</li>
<li id="cite_note-17"><span class="mw-cite-backlink"><b><a href="#cite_ref-17">^</a></b></span> <span class="reference-text"><cite class="citation web">Bashir, Faizan (2018-05-28). <a rel="nofollow" class="external text" href="https://hackernoon.com/what-is-serverless-architecture-what-are-its-pros-and-cons-cc4b804022e9">"What is Serverless Architecture? What are its Pros and Cons?"</a>. <i>Hacker Noon</i><span class="reference-accessdate">. Retrieved <span class="nowrap">2019-04-03</span></span>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Ajournal&amp;rft.genre=unknown&amp;rft.jtitle=Hacker+Noon&amp;rft.atitle=What+is+Serverless+Architecture%3F+What+are+its+Pros+and+Cons%3F&amp;rft.date=2018-05-28&amp;rft.aulast=Bashir&amp;rft.aufirst=Faizan&amp;rft_id=https%3A%2F%2Fhackernoon.com%2Fwhat-is-serverless-architecture-what-are-its-pros-and-cons-cc4b804022e9&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></span>
</li>
<li id="cite_note-18"><span class="mw-cite-backlink"><b><a href="#cite_ref-18">^</a></b></span> <span class="reference-text"><cite class="citation web"><a rel="nofollow" class="external text" href="https://squadex.com/insights/what-is-serverless/">"What Is Serverless? Here's a Plain Answer!"</a>. <i>Squadex</i>. 2019-01-17<span class="reference-accessdate">. Retrieved <span class="nowrap">2019-04-03</span></span>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Ajournal&amp;rft.genre=unknown&amp;rft.jtitle=Squadex&amp;rft.atitle=What+Is+Serverless%3F+Here%27s+a+Plain+Answer%21&amp;rft.date=2019-01-17&amp;rft_id=https%3A%2F%2Fsquadex.com%2Finsights%2Fwhat-is-serverless%2F&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></span>
</li>
</ol></div></div>
<h2><span class="mw-headline" id="Further_reading">Further reading</span><span class="mw-editsection"><span class="mw-editsection-bracket">[</span><a href="/w/index.php?title=Serverless_computing&amp;action=edit&amp;section=17" title="Edit section: Further reading">edit</a><span class="mw-editsection-bracket">]</span></span></h2>
<ul><li><cite class="citation web">Roberts, Mike (25 July 2016). <a rel="nofollow" class="external text" href="http://martinfowler.com/articles/serverless.html">"Serverless Architectures"</a>. <i>MartinFowler.com</i><span class="reference-accessdate">. Retrieved <span class="nowrap">30 July</span> 2016</span>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Ajournal&amp;rft.genre=unknown&amp;rft.jtitle=MartinFowler.com&amp;rft.atitle=Serverless+Architectures&amp;rft.date=2016-07-25&amp;rft.aulast=Roberts&amp;rft.aufirst=Mike&amp;rft_id=http%3A%2F%2Fmartinfowler.com%2Farticles%2Fserverless.html&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></li>
<li><cite class="citation web">Jamieson, Frazer (4 September 2017). <a rel="nofollow" class="external text" href="http://www.bcs.org/content/conWebDoc/58491">"Losing the server? Everybody is talking about serverless architecture"</a>. <i>BCS, the Chartered Institute for IT</i><span class="reference-accessdate">. Retrieved <span class="nowrap">7 November</span> 2017</span>.</cite><span title="ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Ajournal&amp;rft.genre=unknown&amp;rft.jtitle=BCS%2C+the+Chartered+Institute+for+IT&amp;rft.atitle=Losing+the+server%3F+Everybody+is+talking+about+serverless+architecture&amp;rft.date=2017-09-04&amp;rft.aulast=Jamieson&amp;rft.aufirst=Frazer&amp;rft_id=http%3A%2F%2Fwww.bcs.org%2Fcontent%2FconWebDoc%2F58491&amp;rfr_id=info%3Asid%2Fen.wikipedia.org%3AServerless+computing" class="Z3988"></span><link rel="mw-deduplicated-inline-style" href="mw-data:TemplateStyles:r935243608"/></li></ul>
<!-- 
NewPP limit report
Parsed by mw1350
Cached time: 20200306222947
Cache expiry: 2592000
Dynamic content: false
Complications: [vary‐revision‐sha1]
CPU time usage: 0.240 seconds
Real time usage: 0.283 seconds
Preprocessor visited node count: 902/1000000
Post‐expand include size: 29413/2097152 bytes
Template argument size: 84/2097152 bytes
Highest expansion depth: 8/40
Expensive parser function count: 0/500
Unstrip recursion depth: 1/20
Unstrip post‐expand size: 60697/5000000 bytes
Number of Wikibase entities loaded: 0/400
Lua time usage: 0.140/10.000 seconds
Lua memory usage: 3.38 MB/50 MB
-->
<!--
Transclusion expansion time report (%,ms,calls,template)
100.00%  232.711      1 -total
 81.11%  188.763      1 Template:Reflist
 69.13%  160.874     18 Template:Cite_web
 12.31%   28.639      1 Template:See_also
  3.23%    7.516      1 Template:Cite_news
  1.05%    2.442      1 Template:Main_other
-->

<!-- Saved in parser cache with key enwiki:pcache:idhash:51040757-0!canonical and timestamp 20200306222947 and revision id 944226992
 -->
</div><noscript><img src="//en.wikipedia.org/wiki/Special:CentralAutoLogin/start?type=1x1" alt="" title="" width="1" height="1" style="border: none; position: absolute;" /></noscript></div>
		<div class="printfooter">Retrieved from "<a dir="ltr" href="https://en.wikipedia.org/w/index.php?title=Serverless_computing&amp;oldid=944226992">https://en.wikipedia.org/w/index.php?title=Serverless_computing&amp;oldid=944226992</a>"</div>
		<div id="catlinks" class="catlinks" data-mw="interface"><div id="mw-normal-catlinks" class="mw-normal-catlinks"><a href="/wiki/Help:Category" title="Help:Category">Categories</a>: <ul><li><a href="/wiki/Category:Serverless_computing" title="Category:Serverless computing">Serverless computing</a></li><li><a href="/wiki/Category:Cloud_computing" title="Category:Cloud computing">Cloud computing</a></li></ul></div></div>
		<div class="visualClear"></div>
		
	</div>
</div>
<div id='mw-data-after-content'>
	<div class="read-more-container"></div>
</div>

<div id="mw-navigation">
    <h2>Navigation menu</h2>
    <div id="mw-head">
        
        <div id="p-personal" role="navigation" class="" aria-labelledby="p-personal-label">
        	<h3 id="p-personal-label">Personal tools</h3>
        	<ul >
        		
        		<li id="pt-anonuserpage">Not logged in</li>
        		<li id="pt-anontalk"><a href="/wiki/Special:MyTalk" title="Discussion about edits from this IP address [n]" accesskey="n">Talk</a></li><li id="pt-anoncontribs"><a href="/wiki/Special:MyContributions" title="A list of edits made from this IP address [y]" accesskey="y">Contributions</a></li><li id="pt-createaccount"><a href="/w/index.php?title=Special:CreateAccount&amp;returnto=Serverless+computing" title="You are encouraged to create an account and log in; however, it is not mandatory">Create account</a></li><li id="pt-login"><a href="/w/index.php?title=Special:UserLogin&amp;returnto=Serverless+computing" title="You&#039;re encouraged to log in; however, it&#039;s not mandatory. [o]" accesskey="o">Log in</a></li>
        	</ul>
        </div>
        <div id="left-navigation">
            <div id="p-namespaces" role="navigation" class="vectorTabs " aria-labelledby="p-namespaces-label">
            	<h3 id="p-namespaces-label">Namespaces</h3>
            	<ul >
            		<li id="ca-nstab-main" class="selected"><a href="/wiki/Serverless_computing" title="View the content page [c]" accesskey="c">Article</a></li><li id="ca-talk"><a href="/wiki/Talk:Serverless_computing" rel="discussion" title="Discussion about the content page [t]" accesskey="t">Talk</a></li>
            	</ul>
            </div>
            <div id="p-variants" role="navigation" class="vectorMenu emptyPortlet" aria-labelledby="p-variants-label">
            	<input type="checkbox" class="vectorMenuCheckbox" aria-labelledby="p-variants-label" />
            	<h3 id="p-variants-label">
            		<span>Variants</span>
            	</h3>
            	<ul class="menu" >
            		
            	</ul>
            </div>
        </div>
        <div id="right-navigation">
            <div id="p-views" role="navigation" class="vectorTabs " aria-labelledby="p-views-label">
            	<h3 id="p-views-label">Views</h3>
            	<ul >
            		<li id="ca-view" class="collapsible selected"><a href="/wiki/Serverless_computing">Read</a></li><li id="ca-edit" class="collapsible"><a href="/w/index.php?title=Serverless_computing&amp;action=edit" title="Edit this page [e]" accesskey="e">Edit</a></li><li id="ca-history" class="collapsible"><a href="/w/index.php?title=Serverless_computing&amp;action=history" title="Past revisions of this page [h]" accesskey="h">View history</a></li>
            	</ul>
            </div>
            <div id="p-cactions" role="navigation" class="vectorMenu emptyPortlet" aria-labelledby="p-cactions-label">
            	<input type="checkbox" class="vectorMenuCheckbox" aria-labelledby="p-cactions-label" />
            	<h3 id="p-cactions-label">
            		<span>More</span>
            	</h3>
            	<ul class="menu" >
            		
            	</ul>
            </div>
            <div id="p-search" role="search">
            	<h3 >
            		<label for="searchInput">Search</label>
            	</h3>
            	<form action="/w/index.php" id="searchform">
            		<div id="simpleSearch">
            			<input type="search" name="search" placeholder="Search Wikipedia" title="Search Wikipedia [f]" accesskey="f" id="searchInput"/>
            			<input type="hidden" value="Special:Search" name="title"/>
            			<input type="submit" name="fulltext" value="Search" title="Search Wikipedia for this text" id="mw-searchButton" class="searchButton mw-fallbackSearchButton"/>
            			<input type="submit" name="go" value="Go" title="Go to a page with this exact name if it exists" id="searchButton" class="searchButton"/>
            		</div>
            	</form>
            </div>
        </div>
    </div>
    
    <div id="mw-panel">
    	<div id="p-logo" role="banner">
    		<a  title="Visit the main page" class="mw-wiki-logo" href="/wiki/Main_Page"></a>
    	</div>
    	<div class="portal" role="navigation" id="p-navigation"  aria-labelledby="p-navigation-label">
    		<h3  id="p-navigation-label">
    			Navigation
    		</h3>
    		<div class="body">
    			<ul><li id="n-mainpage-description"><a href="/wiki/Main_Page" title="Visit the main page [z]" accesskey="z">Main page</a></li><li id="n-contents"><a href="/wiki/Wikipedia:Contents" title="Guides to browsing Wikipedia">Contents</a></li><li id="n-featuredcontent"><a href="/wiki/Wikipedia:Featured_content" title="Featured content – the best of Wikipedia">Featured content</a></li><li id="n-currentevents"><a href="/wiki/Portal:Current_events" title="Find background information on current events">Current events</a></li><li id="n-randompage"><a href="/wiki/Special:Random" title="Load a random article [x]" accesskey="x">Random article</a></li><li id="n-sitesupport"><a href="https://donate.wikimedia.org/wiki/Special:FundraiserRedirector?utm_source=donate&amp;utm_medium=sidebar&amp;utm_campaign=C13_en.wikipedia.org&amp;uselang=en" title="Support us">Donate to Wikipedia</a></li><li id="n-shoplink"><a href="//shop.wikimedia.org" title="Visit the Wikipedia store">Wikipedia store</a></li></ul>
    			
    		</div>
    	</div>
    	
    	<div class="portal" role="navigation" id="p-interaction"  aria-labelledby="p-interaction-label">
    		<h3  id="p-interaction-label">
    			Interaction
    		</h3>
    		<div class="body">
    			<ul><li id="n-help"><a href="/wiki/Help:Contents" title="Guidance on how to use and edit Wikipedia">Help</a></li><li id="n-aboutsite"><a href="/wiki/Wikipedia:About" title="Find out about Wikipedia">About Wikipedia</a></li><li id="n-portal"><a href="/wiki/Wikipedia:Community_portal" title="About the project, what you can do, where to find things">Community portal</a></li><li id="n-recentchanges"><a href="/wiki/Special:RecentChanges" title="A list of recent changes in the wiki [r]" accesskey="r">Recent changes</a></li><li id="n-contactpage"><a href="//en.wikipedia.org/wiki/Wikipedia:Contact_us" title="How to contact Wikipedia">Contact page</a></li></ul>
    			
    		</div>
    	</div>
    	
    	<div class="portal" role="navigation" id="p-tb"  aria-labelledby="p-tb-label">
    		<h3  id="p-tb-label">
    			Tools
    		</h3>
    		<div class="body">
    			<ul><li id="t-whatlinkshere"><a href="/wiki/Special:WhatLinksHere/Serverless_computing" title="List of all English Wikipedia pages containing links to this page [j]" accesskey="j">What links here</a></li><li id="t-recentchangeslinked"><a href="/wiki/Special:RecentChangesLinked/Serverless_computing" rel="nofollow" title="Recent changes in pages linked from this page [k]" accesskey="k">Related changes</a></li><li id="t-upload"><a href="/wiki/Wikipedia:File_Upload_Wizard" title="Upload files [u]" accesskey="u">Upload file</a></li><li id="t-specialpages"><a href="/wiki/Special:SpecialPages" title="A list of all special pages [q]" accesskey="q">Special pages</a></li><li id="t-permalink"><a href="/w/index.php?title=Serverless_computing&amp;oldid=944226992" title="Permanent link to this revision of the page">Permanent link</a></li><li id="t-info"><a href="/w/index.php?title=Serverless_computing&amp;action=info" title="More information about this page">Page information</a></li><li id="t-wikibase"><a href="https://www.wikidata.org/wiki/Special:EntityPage/Q3958022" title="Link to connected data repository item [g]" accesskey="g">Wikidata item</a></li><li id="t-cite"><a href="/w/index.php?title=Special:CiteThisPage&amp;page=Serverless_computing&amp;id=944226992&amp;wpFormIdentifier=titleform" title="Information on how to cite this page">Cite this page</a></li></ul>
    			
    		</div>
    	</div>
    	
    	<div class="portal" role="navigation" id="p-coll-print_export"  aria-labelledby="p-coll-print_export-label">
    		<h3  id="p-coll-print_export-label">
    			Print/export
    		</h3>
    		<div class="body">
    			<ul><li id="coll-create_a_book"><a href="/w/index.php?title=Special:Book&amp;bookcmd=book_creator&amp;referer=Serverless+computing">Create a book</a></li><li id="coll-download-as-rl"><a href="/w/index.php?title=Special:ElectronPdf&amp;page=Serverless+computing&amp;action=show-download-screen">Download as PDF</a></li><li id="t-print"><a href="/w/index.php?title=Serverless_computing&amp;printable=yes" title="Printable version of this page [p]" accesskey="p">Printable version</a></li></ul>
    			
    		</div>
    	</div>
    	
    	<div class="portal" role="navigation" id="p-lang"  aria-labelledby="p-lang-label">
    		<h3  id="p-lang-label">
    			Languages
    		</h3>
    		<div class="body">
    			<ul><li class="interlanguage-link interwiki-et"><a href="https://et.wikipedia.org/wiki/Serverivaba_andmet%C3%B6%C3%B6tlus" title="Serverivaba andmetöötlus – Estonian" lang="et" hreflang="et" class="interlanguage-link-target">Eesti</a></li><li class="interlanguage-link interwiki-fa"><a href="https://fa.wikipedia.org/wiki/%D8%B1%D8%A7%DB%8C%D8%A7%D9%86%D8%B4_%D8%A8%DB%8C%E2%80%8C%D8%B3%D8%B1%D9%88%D8%B1" title="رایانش بی‌سرور – Persian" lang="fa" hreflang="fa" class="interlanguage-link-target">فارسی</a></li><li class="interlanguage-link interwiki-fr"><a href="https://fr.wikipedia.org/wiki/Informatique_sans_serveur" title="Informatique sans serveur – French" lang="fr" hreflang="fr" class="interlanguage-link-target">Français</a></li><li class="interlanguage-link interwiki-ko"><a href="https://ko.wikipedia.org/wiki/%EC%84%9C%EB%B2%84%EB%A6%AC%EC%8A%A4_%EC%BB%B4%ED%93%A8%ED%8C%85" title="서버리스 컴퓨팅 – Korean" lang="ko" hreflang="ko" class="interlanguage-link-target">한국어</a></li><li class="interlanguage-link interwiki-id"><a href="https://id.wikipedia.org/wiki/Komputasi_tanpa_server" title="Komputasi tanpa server – Indonesian" lang="id" hreflang="id" class="interlanguage-link-target">Bahasa Indonesia</a></li><li class="interlanguage-link interwiki-it"><a href="https://it.wikipedia.org/wiki/Serverless" title="Serverless – Italian" lang="it" hreflang="it" class="interlanguage-link-target">Italiano</a></li><li class="interlanguage-link interwiki-ja"><a href="https://ja.wikipedia.org/wiki/%E3%82%B5%E3%83%BC%E3%83%90%E3%83%BC%E3%83%AC%E3%82%B9%E3%83%BB%E3%82%B3%E3%83%B3%E3%83%94%E3%83%A5%E3%83%BC%E3%83%86%E3%82%A3%E3%83%B3%E3%82%B0" title="サーバーレス・コンピューティング – Japanese" lang="ja" hreflang="ja" class="interlanguage-link-target">日本語</a></li><li class="interlanguage-link interwiki-ru"><a href="https://ru.wikipedia.org/wiki/%D0%91%D0%B5%D1%81%D1%81%D0%B5%D1%80%D0%B2%D0%B5%D1%80%D0%BD%D1%8B%D0%B5_%D0%B2%D1%8B%D1%87%D0%B8%D1%81%D0%BB%D0%B5%D0%BD%D0%B8%D1%8F" title="Бессерверные вычисления – Russian" lang="ru" hreflang="ru" class="interlanguage-link-target">Русский</a></li><li class="interlanguage-link interwiki-uk"><a href="https://uk.wikipedia.org/wiki/%D0%91%D0%B5%D0%B7%D1%81%D0%B5%D1%80%D0%B2%D0%B5%D1%80%D0%BD%D1%96_%D0%BE%D0%B1%D1%87%D0%B8%D1%81%D0%BB%D0%B5%D0%BD%D0%BD%D1%8F" title="Безсерверні обчислення – Ukrainian" lang="uk" hreflang="uk" class="interlanguage-link-target">Українська</a></li><li class="interlanguage-link interwiki-zh"><a href="https://zh.wikipedia.org/wiki/%E7%84%A1%E4%BC%BA%E6%9C%8D%E5%99%A8%E8%A8%88%E7%AE%97" title="無伺服器計算 – Chinese" lang="zh" hreflang="zh" class="interlanguage-link-target">中文</a></li></ul>
    			<div class="after-portlet after-portlet-lang"><span class="wb-langlinks-edit wb-langlinks-link"><a href="https://www.wikidata.org/wiki/Special:EntityPage/Q3958022#sitelinks-wikipedia" title="Edit interlanguage links" class="wbc-editpage">Edit links</a></span></div>
    		</div>
    	</div>
    	
    </div>
</div>

<div id="footer" role="contentinfo" >
	<ul id="footer-info" class="">
		<li id="footer-info-lastmod"> This page was last edited on 6 March 2020, at 14:32<span class="anonymous-show">&#160;(UTC)</span>.</li>
		<li id="footer-info-copyright">Text is available under the <a rel="license" href="//en.wikipedia.org/wiki/Wikipedia:Text_of_Creative_Commons_Attribution-ShareAlike_3.0_Unported_License">Creative Commons Attribution-ShareAlike License</a><a rel="license" href="//creativecommons.org/licenses/by-sa/3.0/" style="display:none;"></a>;
additional terms may apply.  By using this site, you agree to the <a href="//foundation.wikimedia.org/wiki/Terms_of_Use">Terms of Use</a> and <a href="//foundation.wikimedia.org/wiki/Privacy_policy">Privacy Policy</a>. Wikipedia® is a registered trademark of the <a href="//www.wikimediafoundation.org/">Wikimedia Foundation, Inc.</a>, a non-profit organization.</li>
	</ul>
	<ul id="footer-places" class="">
		<li id="footer-places-privacy"><a href="https://foundation.wikimedia.org/wiki/Privacy_policy" class="extiw" title="wmf:Privacy policy">Privacy policy</a></li>
		<li id="footer-places-about"><a href="/wiki/Wikipedia:About" title="Wikipedia:About">About Wikipedia</a></li>
		<li id="footer-places-disclaimer"><a href="/wiki/Wikipedia:General_disclaimer" title="Wikipedia:General disclaimer">Disclaimers</a></li>
		<li id="footer-places-contact"><a href="//en.wikipedia.org/wiki/Wikipedia:Contact_us">Contact Wikipedia</a></li>
		<li id="footer-places-developers"><a href="https://www.mediawiki.org/wiki/Special:MyLanguage/How_to_contribute">Developers</a></li>
		<li id="footer-places-statslink"><a href="https://stats.wikimedia.org/#/en.wikipedia.org">Statistics</a></li>
		<li id="footer-places-cookiestatement"><a href="https://foundation.wikimedia.org/wiki/Cookie_statement">Cookie statement</a></li>
		<li id="footer-places-mobileview"><a href="//en.m.wikipedia.org/w/index.php?title=Serverless_computing&amp;mobileaction=toggle_view_mobile" class="noprint stopMobileRedirectToggle">Mobile view</a></li>
	</ul>
	<ul id="footer-icons" class="noprint">
		<li id="footer-copyrightico"><a href="https://wikimediafoundation.org/"><img src="/static/images/wikimedia-button.png" srcset="/static/images/wikimedia-button-1.5x.png 1.5x, /static/images/wikimedia-button-2x.png 2x" width="88" height="31" alt="Wikimedia Foundation"/></a></li>
		<li id="footer-poweredbyico"><a href="https://www.mediawiki.org/"><img src="/static/images/poweredby_mediawiki_88x31.png" alt="Powered by MediaWiki" srcset="/static/images/poweredby_mediawiki_132x47.png 1.5x, /static/images/poweredby_mediawiki_176x62.png 2x" width="88" height="31"/></a></li>
	</ul>
	<div style="clear: both;"></div>
</div>

<script>(RLQ=window.RLQ||[]).push(function(){mw.config.set({"wgPageParseReport":{"limitreport":{"cputime":"0.240","walltime":"0.283","ppvisitednodes":{"value":902,"limit":1000000},"postexpandincludesize":{"value":29413,"limit":2097152},"templateargumentsize":{"value":84,"limit":2097152},"expansiondepth":{"value":8,"limit":40},"expensivefunctioncount":{"value":0,"limit":500},"unstrip-depth":{"value":1,"limit":20},"unstrip-size":{"value":60697,"limit":5000000},"entityaccesscount":{"value":0,"limit":400},"timingprofile":["100.00%  232.711      1 -total"," 81.11%  188.763      1 Template:Reflist"," 69.13%  160.874     18 Template:Cite_web"," 12.31%   28.639      1 Template:See_also","  3.23%    7.516      1 Template:Cite_news","  1.05%    2.442      1 Template:Main_other"]},"scribunto":{"limitreport-timeusage":{"value":"0.140","limit":"10.000"},"limitreport-memusage":{"value":3541891,"limit":52428800}},"cachereport":{"origin":"mw1350","timestamp":"20200306222947","ttl":2592000,"transientcontent":false}}});});</script>
<script type="application/ld+json">{"@context":"https:\/\/schema.org","@type":"Article","name":"Serverless computing","url":"https:\/\/en.wikipedia.org\/wiki\/Serverless_computing","sameAs":"http:\/\/www.wikidata.org\/entity\/Q3958022","mainEntity":"http:\/\/www.wikidata.org\/entity\/Q3958022","author":{"@type":"Organization","name":"Contributors to Wikimedia projects"},"publisher":{"@type":"Organization","name":"Wikimedia Foundation, Inc.","logo":{"@type":"ImageObject","url":"https:\/\/www.wikimedia.org\/static\/images\/wmf-hor-googpub.png"}},"datePublished":"2016-07-10T15:20:20Z","dateModified":"2020-03-06T14:32:08Z","headline":"type of cloud computing"}</script>
<script>(RLQ=window.RLQ||[]).push(function(){mw.config.set({"wgBackendResponseTime":205,"wgHostname":"mw1333"});});</script></body></html>
